=== debian/changelog ===
cura-engine (1:4.13.0-1) unstable; urgency=medium

  [ Debian Janitor ]
  * Remove constraints unnecessary since buster:
    + Build-Depends: Drop versioned constraint on cmake, pkg-config and
      protobuf-compiler.

  [ Christoph Berg ]
  * New upstream version 4.13.0.

 -- Christoph Berg <myon@debian.org>  Mon, 17 Jan 2022 15:00:08 +0100
