=== debian/control ===
Source: cura-engine
Priority: optional
Maintainer: Debian 3-D Printing Packages <3dprinter-general@lists.alioth.debian.org>
Uploaders: Gregor Riepl <onitake@gmail.com>,
 Christoph Berg <myon@debian.org>,
Build-Depends: debhelper-compat (= 12), cmake,
 pkg-config,
 libcppunit-dev,
 protobuf-compiler, libprotobuf-dev,
 rapidjson-dev, libpolyclipping-dev,
 libarcus-dev (>= 4.4.0),
 libgmock-dev,
 libstb-dev,
Standards-Version: 4.1.4
Section: utils
Homepage: https://github.com/Ultimaker/CuraEngine
Vcs-Browser: https://salsa.debian.org/3dprinting-team/cura-engine
Vcs-Git: https://salsa.debian.org/3dprinting-team/cura-engine.git

Package: cura-engine
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: command line slicer engine for 3d printing
 The CuraEngine is a C++ console application for 3D printing
 GCode generation. It has been made as a better and faster
 alternative to the old Skeinforge engine.
