=== debian/changelog ===
cura-engine (1:5.0.0-6) unstable; urgency=medium

  * Add cstdint include to address build failure with g++ 15.
    Closes: #1096492

 -- Gregor Riepl <onitake@gmail.com>  Mon, 01 Sep 2025 20:00:31 +0000

cura-engine (1:5.0.0-5) unstable; urgency=medium

  * Replace deprecated pkg-config dependency.
  * Include missing iomanip header in unit test.
    Closes: #1077406

 -- Gregor Riepl <onitake@gmail.com>  Tue, 30 Jul 2024 20:25:00 +0300

cura-engine (1:5.0.0-4) unstable; urgency=medium

  * Fix failing unit test. Closes: #1040252
  * Fix gcc-13 compatibility. Closes: #1037614
  * Fix errors with obsolete adhesion_extruder_nr parameter.
    Thanks to Dan Bungert (Canonical) for reporting this.
    Closes: #1040806
  * Fix rounding errors on i686. Closes: #1041808
  * Drop previous patch for rounding errors.
    It's covered by the round error fix.

 -- Gregor Riepl <onitake@gmail.com>  Mon, 24 Jul 2023 22:09:39 +0200

cura-engine (1:5.0.0-3) unstable; urgency=medium

  * Tweak lintian overrides to work with old and [new] format.

 -- Christoph Berg <myon@debian.org>  Mon, 03 Jul 2023 22:28:23 +0200

cura-engine (1:5.0.0-2) unstable; urgency=medium

  * Fix Lintian override.

 -- Gregor Riepl <onitake@gmail.com>  Sun, 02 Jul 2023 19:56:06 +0000

cura-engine (1:5.0.0-1) experimental; urgency=medium

  [ Sebastian Kuzminsky ]
  * New upstream version 5.0.0.
  * Remove copyright info for removed files.
  * Bump libarcus build dependency version.
  * Build-depend on libboost-dev.
  * Refresh patch queue.

  [ Christoph Berg ]
  * Update debian/tests/*.json from cura.

 -- Christoph Berg <myon@debian.org>  Fri, 27 May 2022 16:35:18 +0200
