=== debian/control ===
--- 
+++ 
@@ -4,11 +4,12 @@
 Uploaders: Gregor Riepl <onitake@gmail.com>,
  Christoph Berg <myon@debian.org>,
 Build-Depends: debhelper-compat (= 12), cmake,
- pkg-config,
+ pkgconf,
  libcppunit-dev,
+ libboost-dev,
  protobuf-compiler, libprotobuf-dev,
  rapidjson-dev, libpolyclipping-dev,
- libarcus-dev (>= 4.4.0),
+ libarcus-dev (>= 5.0~beta),
  libgmock-dev,
  libstb-dev,
 Standards-Version: 4.1.4
