=== debian/control ===
Source: cura-engine
Section: utils
Priority: optional
Maintainer: 3-D printer team <3dprinter-general@lists.alioth.debian.org>
Uploaders: Bas Wijnen <wijnen@debian.org>
Build-Depends: debhelper (>= 9), libpolyclipping-dev (>= 6.1.3a), ruby-ronn, pkg-config, python
Standards-Version: 3.9.5
Homepage: https://github.com/Ultimaker/CuraEngine

Package: cura-engine
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: commandline slicer program for 3-D printers
 3-D printers need a toolpath for printing, while what is usually distributed
 is a 3-D model.  A slicer programs converts a model to a toolpath, with user
 defined settings for options such as infill density and printing speed.
 .
 This slicer is the commandline backend of Cura.
