=== debian/rules ===
#!/usr/bin/make -f
# Copyright 2003-2007 Bas Wijnen <wijnen@debian.org>
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.

%:
	dh $@

override_dh_auto_build:
	dh_auto_build
	ronn -r debian/CuraEngine.1.ronn

override_dh_auto_clean:
	dh_auto_clean
	rm -f debian/CuraEngine.1
